*
* Test for ASCII character
*
isascii	LD	AX,#$007F	Range to test
	SJMP	?3		Perform test
*
* Test for alphanumeric character (0-9, A-Z, a-z)
*
isalnum	POP	CX		CX = ret address
	SCALL	isdigit		Is it a digit??
	JE	?2		No, keep looking
?1	BR	CX		Return to caller
*
* Test for alphabetic character (A-Z, a-z)
*
isalpha	POP	CX		CX = ret address
?2	SCALL	isupper		Uppercase??
	JNE	?1		Yes, we have it
	PUSH	CX		Restore ret address
*
* Test for lowercase alphabetic character (a-z)
*
islower	LD	AX,#'az'	Range to test
	SJMP	?3		Perform test
*
* Test for uppercase alphabetic character (A-Z)
*
isupper	LD	AX,#'AZ'	#'AZ'		Range to test
	SJMP	?3		Perform test
*
* Test for graphic (printable) character
*
isgraph	LD	AX,#$217E	Range to test
	SJMP	?3		And proceed
*
* Test for a HEX digit
*
isxdigit POP	CX		CX = ret address
	LD	AX,#'AF'	Range to test
	SCALL	?3		Test it
	JNE	?1		Found it
	LD	AX,#'af'	Range to test
	SCALL	?3		Test it
	JNE	?1		Found it
	PUSH	CX		Restore ret address
*
* Test for an ASCII digit (0-9)
*
isdigit	LD	AX,#'09'	Range to test
* Test argument against range in A:B
?3	CMPB	AX,2[SP]	Test LOWER limit
	JNC	?5		Failed, return FALSE
	CMPB	AX+1,2[SP]	Test UPPER limit
	JH	?5		Failed return FALSE
* Test that upper byte of argument is zero
?4	LDB	AX+1,3[SP]	Get high byte
	ANDB	AX+1,AX+1	Zero??
	JNE	?5		Non-zero, fail
	LDB	AX,#1		return 1
	ANDB	AX,AX		Clear 'Z'
	RET
* Report failure, return FALSE (0)
?5	CLR	AX		Zero result
	RET
*
* Test for CONTROL character
*
iscntrl	LDB	AX,2[SP]	Get argument
	CMPB	AX,#$7F		Delete??
	JE	?4		Yes, test high
	LD	AX,#$001F	CTRL-range
	SJMP	?3		Complete test
*
* Test for a punctuation character
*
ispunct	LDB	AX,2[SP]	Get argument
	PUSH	AX		Pass it on
	SCALL	isalnum		Alphanumeric??
	POP	BX		Clean up
	JNE	?5		Yes, false
*
* Test for printable character
*
isprint	LD	AX,#$207E	Printable range
	SJMP	?3		And test for it
*
* Test for a "space" character
*
isspace	LDB	AX,2[SP]	Get argument
	CMPB	AX,#' '		Space??
	JE	?4		Seems OK
	CMPB	AX,#9		Tab??
	JE	?4		Seems OK
	CMPB	AX,#10		Newline??
	JE	?4		Seems OK
	SJMP	?5		Invalid
