*
* Allocate a block of memory: malloc(size)
*
malloc	LD	CX,2[SP]	Get size
	INC	CX		Add one to insure we get enough
	AND	CX,#$FFFE	Word align
	ST	CX,2[SP]	Resave actual size
* Search memory list for free block
	LD	SI,#?heap	Point to heap
?1	LD	BX,[SI]		Get allocation flag
	AND	BX,BX		End of list?
	JE	?4		Yes, allocate here
	SHL	BX,#1		Convert to bytes
	JC	?2		Allocated, try next
* Check block and see if its large enough
	CMP	BX,2[SP]	Enough memory?
	JC	?3		Yes, allocate here
* This block not suitable, advance to next
?2	ADD	BX,#2		Adjust for overhead
	ADD	SI,BX		Advance to next
	SJMP	?1		And keep looking
* This block is OK to re-allocate
?3	SUB	CX,BX,2[SP]	Remove allocation
	SUB	CX,#2		Adjust for overhead
	JNH	?5		Too small, don't split
* Split this block into two blocks
	LD	BX,2[SP]	Get argument
	ADD	DI,SI,BX	Offset to next block
	SHR	CX,#1		Convert to word count
	ST	CX,2[DI]	Write to memory
	SJMP	?5		And proceed
* Allocate on end of memory
?4	LD	BX,2[SP]	Get requested size
	ADD	DI,SI,BX	DI = end
	SUB	CX,SP,#1000	Enough room?
	CLR	AX		Assume failure
	CMP	DI,CX		In range?
	JH	?6		No, return zero
* Ok to allocate on end
	ST	0,2[DI]		Flag end of list
?5	SHR	BX,#1		Convert to words
	ORB	BX+1,#%10000000	Set allocated flag
	ST	BX,[SI]		Write to memory
	ADD	AX,SI,#2	Return pointer to RAM
?6	RET
*
* Release memory: free(addr)
*
free	LD	CX,2[SP]	Get address
	SUB	CX,#2		Backup to "real" beginning
	LD	SI,#?heap	Point to heap
?10	LD	AX,[SI]		Get memory flag
	AND	AX,AX		End of list?
	JE	?20		Yes, collect garbage
	CMP	SI,CX		Is this it?
	JE	?11		Yes, release
	SHL	AX,#1		Convert to bytes
	ADD	AX,#2		Adjust for overhead
	ADD	SI,AX
	SJMP	?10		And proceed
?11	AND	AX,#$7FFF	Clear busy bit
	ST	AX,[SI]		Resave
* Garbage collection, scan memory allocation blocks and convert any
* contiguous blocks into single blocks. Also, truncate list at last
* allocated block.
?20	LD	SI,#?heap	Point to the heap
?21	LD	AX,[SI]		Get memory allocation
	AND	AX,AX		End of list?
	JE	?26		Yes, exit
	SHL	AX,#1		Get number of bytes
	JC	?24		Block is allocated... check following
* This block is free... check for more free blocks
?22	ADD	AX,#2		Adjust for block size
	ADD	DI,SI,AX	Offset to next
	LD	BX,[DI]		Get size
	AND	BX,BX		Get next
	JE	?25		End of list, truncate
	SHL	BX,#1		Convert to bytes
	JC	?23		This block is allocated
	ADD	AX,BX		Include in size
	SJMP	?22		Keep looking
* Resave this block size
?23	SUB	AX,#2		Remove overhead
	SHR	AX,#1		Convert to words
	ST	AX,[SI]		Save new block size
* Advance to next block
?24	ADD	SI,AX		Advanve
	ADD	SI,#2		Skip overhead
	SJMP	?21		And look for next
* Mark this block as end of list
?25	ST	0,[SI]		End of list
?26	RET
